#! /usr/bin/env python 
from random import *
from bisect import *

import sched,sys,string

class File:
    def __init__(self,id,size):
        self.id=id
        self.size=size
        self.band=1
       

class Peer:
    def __init__(self,tb,ts):
        self.totalband=tb
        self.totalspace=ts
        self.files=[]
        self.accessf=[]
        self.usedband=0
        
    def leftspace(self):
        s=0
        for file in self.files:
           s+=file.size
        return self.totalspace-s

    def leftband(self):
        return self.totalband-self.usedband

    def access(self,peer,band):
        peer.usedband+=band
        self.accessf.append((peer,band))
        
    def choosepeers(self,peers,file):
        global peerserv,cdnserv
        global totalfileband,rejection
        
        band=file.band
        
        if RejectMode==1:
            tband=0
            for peer in peers:
                tband+=peer.leftband()
            tband+=cdn.leftband()
            if tband<band:
                rejection+=1
                return
        
        pingtest=[]
        for peer in peers:
            pingtest.append((uniform(0,1),peer))
        pingtest.sort()
        availableband=0
        for peer in pingtest:
            peerband=peer[1].leftband()
            availableband+=peerband
            if availableband>=band:
                self.access(peer[1],band+peerband-availableband)
                break;
            else:
                self.access(peer[1],peerband)
        
        peerserv+=availableband*file.size
        if availableband<band:
            self.access(cdn,band-availableband)
            cdnserv+=(band-availableband)*file.size
         #   print "-----------------use CDN-------------"
       # else:
        #    print "***good********************"
            ##print "CDN needed", band-availableband
        sc.enter(file.size,1,handler,[LEAVE,self])
        totalfileband+=1
        
    def releasepeers(self):
        global totalfileband
        for (peer,band) in self.accessf:
            peer.usedband-=band
        self.accessf=[]
        totalfileband-=1
        
    def request(self,file):
        global findedlocal
        if file in self.files:
            findedlocal+=1
        else:
            availablepeers=server.request(self,file)
            self.choosepeers(availablepeers,file)
            



class Server:
    def replace(self,peer):
        global totalreplacement
        totalreplacement+=1
        
        while peer.leftspace()<0:
            if replacepolicy=="FIFO":
                peer.files.pop()
            elif replacepolicy=="LFU":
                high=(-1,None)
                for f in peer.files:
                    if f.id>high[0]:
                        high=(f.id,f)
                peer.files.remove(high[1])
            
    
    def request(self,requestpeer,file):
        availablepeers=[]
        for peer in peers:
            if file in peer.files and peer.leftband()>0:
                availablepeers.append(peer)
        requestpeer.files.append(file)
        if requestpeer.leftspace()<0:
            self.replace(requestpeer)
            return availablepeers
        else:
            return availablepeers
        
    



#assume peer have differnet band but same space and request distribution
# total 1000 peers, 1000 files, on avg, 1 request per minutes, 1 request per peer per day.

# 5+2*2+3*2+4=19 avg=1.9
p1=500
p2=200
p3=200
p4=100
filenum=2000

avgfilesize=100
filesizedev=80

avgpeerspace=avgfilesize*string.atoi(sys.argv[3])/1.9
spacedev=avgpeerspace/2

replacepolicy=sys.argv[2]
totalreplacement=0
peerserv=0
cdnserv=0
totalfileband=0
findedlocal=0
rejection=0

tcdnband=string.atoi(sys.argv[4])

if tcdnband>600:
    tcdnband=1000000
    RejectMode=0
else:
    RejectMode=1


cdn=Peer(tcdnband,10000000)

server=Server()        
files=[]
peers=[]
seed(300)

def normaldist(avg,dev):
    r=int(normalvariate(avg,dev))
    if r>1:
        return r
    else:
        return 1
       
for i in range(filenum):
	files.append(File(i,normaldist(avgfilesize,filesizedev)))

for i in range(p1):
	peers.append(Peer(0.25,normaldist(avgpeerspace,spacedev)))
for i in range(p2):
	peers.append(Peer(0.50,normaldist(avgpeerspace*2,spacedev)))
for i in range(p3):
	peers.append(Peer(0.75,normaldist(avgpeerspace*3,spacedev)))
for i in range(p4):
	peers.append(Peer(1.00,normaldist(avgpeerspace*4,spacedev)))


time=0
ARRIVE=0
LEAVE=1
totalarrive=0

def timefunc():
	return time

def delayfunc(t):
	global time
        time+=t
        
class Zipf_Law: 
    def __init__(self,num):
        self.lawlist=[]
        s=0
        for i in range(1,num+1):
            s+=1/pow(i,0.8)
            self.lawlist.append(s)
        self.total=s
    def get(self):
        r=uniform(0,self.total)
        return bisect_left(self.lawlist,r)
        
        
zipf_law=Zipf_Law(filenum)

maxarrive=string.atoi(sys.argv[1])
        
def handler(type,peer):
        global totalarrive,totalreplacement,rejection,findedlocal
	if type == ARRIVE:
		peer.request(files[zipf_law.get()])
                if totalarrive/100.0 == totalarrive/100:
                    print time,cdn.usedband,totalfileband-cdn.usedband,totalreplacement/100.0,rejection/100.0,findedlocal/100.0
                    totalreplacement=0
                    rejection=0
                    findedlocal=0
                    
		if totalarrive<maxarrive:
			newpeer=peers[int(uniform(0,len(peers)))]
			sc.enter(expovariate(1),1,handler,[ARRIVE,newpeer])
			totalarrive+=1
	else:
		peer.releasepeers()
		


###for i in range(10):
###    print files[i].size

##m=[0 for i in range(filenum)]

##for i in range(100000):
##    m[zipf_law.get()]+=1
##for i in range(filenum):
##    print i,m[i]


sc=sched.scheduler(timefunc,delayfunc)
sc.enter(0,1,handler,[ARRIVE,peers[0]])

sc.run()

#print totalreplacement,peerserv,cdnserv

#cc.py maxarrive policy avgpeerfile cdnband
