global tf sink
global stoptime    ;# streaming session ends
global probeCycle  ;# probing frequency
global flows       ;# total number of flows being tracked 
global R           ;# streaming rate

set flows [lindex $argv 0]
set queue [lindex $argv 1]
set rate [lindex $argv 2]
set ecn [lindex $argv 3]
set discount [lindex $argv 4]



proc stop {tracefile} { 
    close $tracefile
    exit
}

proc stream {tracefile} {
    global tf sink
    global ns 
    global stoptime
    global probeCycle
    global flows R
    for {set i 1} {$i <= $flows} {incr i} {
	set rate($i) [$tf($i) rate]
	puts $tracefile "time: [$ns now] rate: $rate($i) Peer$i"
    }
    set curr_rate [expr "$rate(1)" + "$rate(2)"]
    #puts "curr_rate = $curr_rate"
    set i [expr $i -1]
    if {$curr_rate < $R} {
	$tf($i) rate [expr $R - $curr_rate] 
    } else {
	$tf($i) rate 1000
    }
   
    set curr_time [$ns now] 
#    if { $curr_time > 270 } {
#	puts $tracefile "time: [$ns now] rate: 0 Peer$i"
#    } else {
#	puts $tracefile "time: [$ns now] rate: [$tf($i) rate] Peer$i"
#    }
    if { $curr_time < $stoptime } {
	$ns at [expr $curr_time + $probeCycle ] "stream $tracefile"
    }
}

set stoptime 300
set probeCycle 0.5
set R          140000    ;# 90KBps 

set ns [new Simulator]
set tracefile [open tuy.tr w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
set lossylink_(0) [$ns link $node_(r1) $node_(r2)]

source queueSize.tcl
setQueueSize $rate $queue $node_(r1) $node_(r2)

# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRCSink set discount_ $discount
Agent/TFRCSink set printLoss_ 1
Agent/TFRCSink set smooth_ 1
Agent/TFRCSink set algo_ 1
#Agent/TFRC set printStatus_ 1
Agent/TFRC set df_ 0.95
Agent/TFRC set ca_ 1

for {set i 1} {$i <= $flows} {incr i} {
    set node_(s$i) [$ns node]
    
    $ns duplex-link $node_(s$i) $node_(r1) 1.5Mb 120ms $queue
    set lossylink_($i) [$ns link $node_(s$i) $node_(r1)]
    set sink($i) [new Agent/TFRCSink]
    # use printLoss to identify flow 
    $sink($i) set printLoss_ $i
    $ns attach-agent $node_(r2) $sink($i)

    set tf($i) [new Agent/TFRC]
    # use printStatus to identify flow 
    $tf($i) set printStatus_ $i
    if { $i == 1 } { 
	$tf($i) set InitRate_ 35000
    } elseif { $i == 2 } {
	$tf($i) set InitRate_ 35000
    } elseif { $i == 3 } {
	$tf($i) set InitRate_ 35000
    } else {
	$tf($i) set InitRate_ 35000
    }
    
    $ns attach-agent $node_(s$i) $tf($i)
    $ns connect $tf($i) $sink($i)
    
    $ns at 2 "$tf($i) start"
   # if { $i  == 2 } {
	#$ns at [expr $stoptime * 3 / 4]  "$tf($i) fail"
#	$ns at 270  "$tf($i) stop"
#    } else {
	$ns at $stoptime "$tf($i) stop"
#    }

    for {set j 1} {$j <= 1} {incr j} {
	set ind [expr ($i - 1) * 2 + $j - 1]
	set tcp$ind [$ns create-connection TCP/Sack1 $node_(s$i) TCPSink/Sack1 \
		       $node_(r2) 1]
	[set tcp$ind] set window_ 8
	set ftp$ind [[set tcp$ind] attach-app FTP]
	$ns at 0 "[set ftp$ind] start"
	$ns at $stoptime "[set ftp$ind] stop"
    }
}

#$ns at 1 "stream $tracefile"
$ns at $stoptime "stop $tracefile"

set em [new ErrorModel]
$em set rate_ 0.01
$em unit pkt
$em ranvar [new RandomVariable/Uniform]
$lossylink_(1) errormodule $em

#set em1 [new ErrorModel]
#$em1 set rate_ 0.01
#$em1 unit pkt
#$em1 ranvar [new RandomVariable/Uniform]
$lossylink_(0) errormodule $em

#$lossylink_(2) errormodule $em

#set em [new ErrorModule Fid]
#$lossylink_(0) errormodule $em
#$em default pass

#set emod [$lossylink_(0) errormodule]
#set errmodel [new ErrorModel/List]
#$errmodel unit pkt
#$errmodel droplist { 50 150 250 350 450 550 650 750 850 950 1050 1150 1250 1350 1450 1550 1560 1570 1580 1590 1600 1610 1620 1630 1640 1650 1660 1670 1680 1690 1700 1900 2100 2300 2500 2700 2900 3100 3300 3500 3700 3900 4100 }
#$emod insert $errmodel
#$emod bind $errmodel 0

$ns run
