set flows [lindex $argv 0]
set queue [lindex $argv 1]
set rate [lindex $argv 2]
set ecn [lindex $argv 3]
set discount [lindex $argv 4]

global numSupplyPeers
set numSupplyPeers 2

proc stop {} {
 	exit
}

#Create a simulator object
set ns [new Simulator]

#$ns namtrace-all $nf

Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

#Create nodes
set n0 [$ns node]
set n(1) [$ns node]
set n(2) [$ns node]
set n(3) [$ns node]
set n(4) [$ns node]
set n(5) [$ns node]
set n(6) [$ns node]
set n(7) [$ns node]
set n(8) [$ns node]
set n(9) [$ns node]
set n10 [$ns node]
set n11 [$ns node]

$ns duplex-link $n10 $n0 1.5Mb 10ms $queue
set lossylink_ [$ns link $n10 $n0]

source queueSize.tcl
setQueueSize $rate $queue $n10 $n0

#Create links between the nodes
$ns duplex-link $n(1) $n10 1.5Mb 120ms DropTail
$ns duplex-link $n(2) $n10 1.5Mb 130ms DropTail
$ns duplex-link $n(3) $n10 1.5Mb 140ms DropTail
$ns duplex-link $n(4) $n10 1.5Mb 210ms DropTail
$ns duplex-link $n(5) $n10 1.5Mb 220ms DropTail
$ns duplex-link $n(6) $n10 1.5Mb 230ms DropTail
$ns duplex-link $n(7) $n10 1.5Mb 240ms DropTail
$ns duplex-link $n(8) $n10 1.5Mb 270ms DropTail
$ns duplex-link $n(9) $n10 45Mb 300ms DropTail
$ns duplex-link $n10 $n11 45Mb 20ms DropTail

# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRCSink set discount_ $discount
Agent/TFRCSink set printLoss_ 1
Agent/TFRCSink set smooth_ 1
Agent/TFRC set printStatus_ 1
Agent/TFRC set df_ 0.95
Agent/TFRC set ca_ 1

set randomflows 1
if {$randomflows > $flows} {
    set randomflows $flows
}

for {set i 1} {$i <= $numSupplyPeers } {incr i} {
    set tf($i) [$ns create-connection TFRC $n($i) TFRCSink $n0 0]
    if{$i == 1} {
	$tf($i) set rate_ 600Kb
	$tf($i) set InitRate_ 600Kb
    } else {
	$tf($i) set InitRate_ 300Kb
    } 
    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

    $ns at 0 "[set tf($i)] start"
    $ns at 20 "[set tf($i)] stop"

    for {set j 0} {$j < $randomflows} {incr j} {
	set ind [expr $j * $numSupplyPeers + $i - 1]
	set tcp$ind [$ns create-connection TCP/Sack1 $n($i) TCPSink/Sack1 $n11 1]
	[set tcp$ind] set window_ 8
	set ftp$ind [[set tcp$ind] attach-app FTP]
	$ns at 0 "[set ftp$ind] start"
	$ns at 20 "[set ftp$ind] stop"
    }
}

$ns at 20 "stop"

set em [new ErrorModule Fid]
$lossylink_ errormodule $em
$em default pass

set emod [$lossylink_ errormodule]
set errmodel [new ErrorModel/List]
$errmodel unit pkt
$errmodel droplist { 50 150 250 350 450 550 650 750 850 950 1050 1150 1250 1350 1450 1550 1560 1570 1580 1590 1600 1610 1620 1630 1640 1650 1660 1670 1680 1690 1700 1900 2100 2300 2500 2700 2900 3100 3300 3500 3700 3900 4100 }
$emod insert $errmodel
$emod bind $errmodel 0

#Run the simulation
$ns run
